Index: sansmodels/src/sans/models/c_models/coreshellcylinder.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/coreshellcylinder.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
+++ sansmodels/src/sans/models/c_models/coreshellcylinder.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
@@ -0,0 +1,214 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ *	TODO: refactor so that we pull in the old sansmodels.c_extensions
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libCylinder.h"
+	#include "core_shell_cylinder.h"
+}
+
+CoreShellCylinderModel :: CoreShellCylinderModel() {
+	scale      = Parameter(1.0);
+	radius     = Parameter(20.0, true);
+	radius.set_min(0.0);
+	thickness  = Parameter(10.0, true);
+	thickness.set_min(0.0);
+	length     = Parameter(400.0, true);
+	length.set_min(0.0);
+	core_sld   = Parameter(1.e-6);
+	shell_sld  = Parameter(4.e-6);
+	solvent_sld= Parameter(1.e-6);
+	background = Parameter(0.0);
+	axis_theta = Parameter(0.0, true);
+	axis_phi   = Parameter(0.0, true);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double CoreShellCylinderModel :: operator()(double q) {
+	double dp[8];
+
+	dp[0] = scale();
+	dp[1] = radius();
+	dp[2] = thickness();
+	dp[3] = length();
+	dp[4] = core_sld();
+	dp[5] = shell_sld();
+	dp[6] = solvent_sld();
+	dp[7] = 0.0;
+
+	// Get the dispersion points for the radius
+	vector<WeightPoint> weights_rad;
+	radius.get_weights(weights_rad);
+
+	// Get the dispersion points for the thickness
+	vector<WeightPoint> weights_thick;
+	thickness.get_weights(weights_thick);
+
+	// Get the dispersion points for the length
+	vector<WeightPoint> weights_len;
+	length.get_weights(weights_len);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad.size(); i++) {
+		dp[1] = weights_rad[i].value;
+
+		// Loop over length weight points
+		for(int j=0; j<weights_len.size(); j++) {
+			dp[3] = weights_len[j].value;
+
+			// Loop over thickness weight points
+			for(int k=0; k<weights_thick.size(); k++) {
+				dp[2] = weights_thick[k].value;
+
+				sum += weights_rad[i].weight
+					* weights_len[j].weight
+					* weights_thick[k].weight
+					* CoreShellCylinder(dp, q);
+				norm += weights_rad[i].weight
+				* weights_len[j].weight
+				* weights_thick[k].weight;
+			}
+		}
+	}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double CoreShellCylinderModel :: operator()(double qx, double qy) {
+	CoreShellCylinderParameters dp;
+	// Fill parameter array
+	dp.scale      = scale();
+	dp.radius     = radius();
+	dp.thickness  = thickness();
+	dp.length     = length();
+	dp.core_sld   = core_sld();
+	dp.shell_sld  = shell_sld();
+	dp.solvent_sld= solvent_sld();
+	dp.background = 0.0;
+	dp.axis_theta = axis_theta();
+	dp.axis_phi   = axis_phi();
+
+	// Get the dispersion points for the radius
+	vector<WeightPoint> weights_rad;
+	radius.get_weights(weights_rad);
+
+	// Get the dispersion points for the thickness
+	vector<WeightPoint> weights_thick;
+	thickness.get_weights(weights_thick);
+
+	// Get the dispersion points for the length
+	vector<WeightPoint> weights_len;
+	length.get_weights(weights_len);
+
+	// Get angular averaging for theta
+	vector<WeightPoint> weights_theta;
+	axis_theta.get_weights(weights_theta);
+
+	// Get angular averaging for phi
+	vector<WeightPoint> weights_phi;
+	axis_phi.get_weights(weights_phi);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad.size(); i++) {
+		dp.radius = weights_rad[i].value;
+
+
+		// Loop over length weight points
+		for(int j=0; j<weights_len.size(); j++) {
+			dp.length = weights_len[j].value;
+
+			// Loop over thickness weight points
+			for(int m=0; m<weights_thick.size(); m++) {
+				dp.thickness = weights_thick[m].value;
+
+			// Average over theta distribution
+			for(int k=0; k<weights_theta.size(); k++) {
+				dp.axis_theta = weights_theta[k].value;
+
+				// Average over phi distribution
+				for(int l=0; l<weights_phi.size(); l++) {
+					dp.axis_phi = weights_phi[l].value;
+
+					double _ptvalue = weights_rad[i].weight
+						* weights_len[j].weight
+						* weights_thick[m].weight
+						* weights_theta[k].weight
+						* weights_phi[l].weight
+						* core_shell_cylinder_analytical_2DXY(&dp, qx, qy);
+					if (weights_theta.size()>1) {
+						_ptvalue *= sin(weights_theta[k].value);
+					}
+					sum += _ptvalue;
+
+					norm += weights_rad[i].weight
+						* weights_len[j].weight
+						* weights_thick[m].weight
+						* weights_theta[k].weight
+						* weights_phi[l].weight;
+
+				}
+			}
+			}
+		}
+	}
+	// Averaging in theta needs an extra normalization
+	// factor to account for the sin(theta) term in the
+	// integration (see documentation).
+	if (weights_theta.size()>1) norm = norm / asin(1.0);
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the cylinder
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double CoreShellCylinderModel :: evaluate_rphi(double q, double phi) {
+	double qx = q*cos(phi);
+	double qy = q*sin(phi);
+	return (*this).operator()(qx, qy);
+}
Index: sansmodels/src/sans/models/c_models/coreshellsphere.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/coreshellsphere.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
+++ sansmodels/src/sans/models/c_models/coreshellsphere.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
@@ -0,0 +1,114 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libSphere.h"
+}
+
+CoreShellModel :: CoreShellModel() {
+	scale      = Parameter(1.0);
+	radius     = Parameter(60.0, true);
+	radius.set_min(0.0);
+	thickness  = Parameter(10.0, true);
+	thickness.set_min(0.0);
+	core_sld   = Parameter(1.e-6);
+	shell_sld  = Parameter(2.e-6);
+	solvent_sld = Parameter(3.e-6);
+	background = Parameter(0.0);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double CoreShellModel :: operator()(double q) {
+	double dp[7];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+
+	dp[0] = scale();
+	dp[1] = radius();
+	dp[2] = thickness();
+	dp[3] = core_sld();
+	dp[4] = shell_sld();
+	dp[5] = solvent_sld();
+	dp[6] = 0.0;
+
+
+	// Get the dispersion points for the radius
+	vector<WeightPoint> weights_rad;
+	radius.get_weights(weights_rad);
+
+	// Get the dispersion points for the thickness
+	vector<WeightPoint> weights_thick;
+	thickness.get_weights(weights_thick);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad.size(); i++) {
+		dp[1] = weights_rad[i].value;
+
+		// Loop over thickness weight points
+		for(int j=0; j<weights_thick.size(); j++) {
+			dp[2] = weights_thick[j].value;
+
+			sum += weights_rad[i].weight
+				* weights_thick[j].weight * CoreShellForm(dp, q);
+			norm += weights_rad[i].weight
+				* weights_thick[j].weight;
+		}
+	}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double CoreShellModel :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the sphere
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double CoreShellModel :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
Index: sansmodels/src/sans/models/c_models/cylinder.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/cylinder.cpp	(revision af03ddd0932915d6659404ab7824e4223ea2944f)
+++ sansmodels/src/sans/models/c_models/cylinder.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
@@ -189,4 +189,5 @@
 
 	printf("Length = %g\n", c.length());
+	printf("I(Qx=%g,Qy=%g) = %g\n", 0.001, 0.001, c(0.001, 0.001));
 	printf("I(Q=%g) = %g\n", 0.001, c(0.001));
 	c.radius.dispersion = new GaussianDispersion();
Index: sansmodels/src/sans/models/c_models/ellipsoid.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/ellipsoid.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
+++ sansmodels/src/sans/models/c_models/ellipsoid.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
@@ -0,0 +1,183 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ *	TODO: refactor so that we pull in the old sansmodels.c_extensions
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libCylinder.h"
+	#include "ellipsoid.h"
+}
+
+EllipsoidModel :: EllipsoidModel() {
+	scale      = Parameter(1.0);
+	radius_a   = Parameter(20.0, true);
+	radius_a.set_min(0.0);
+	radius_b   = Parameter(400.0, true);
+	radius_b.set_min(0.0);
+	contrast   = Parameter(3.e-6);
+	background = Parameter(0.0);
+	axis_theta  = Parameter(1.57, true);
+	axis_phi    = Parameter(0.0, true);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double EllipsoidModel :: operator()(double q) {
+	double dp[5];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = radius_a();
+	dp[2] = radius_b();
+	dp[3] = contrast();
+	dp[4] = 0.0;
+
+	// Get the dispersion points for the radius_a
+	vector<WeightPoint> weights_rad_a;
+	radius_a.get_weights(weights_rad_a);
+
+	// Get the dispersion points for the radius_b
+	vector<WeightPoint> weights_rad_b;
+	radius_b.get_weights(weights_rad_b);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over radius_a weight points
+	for(int i=0; i<weights_rad_a.size(); i++) {
+		dp[1] = weights_rad_a[i].value;
+
+		// Loop over radius_b weight points
+		for(int j=0; j<weights_rad_b.size(); j++) {
+			dp[2] = weights_rad_b[j].value;
+
+			sum += weights_rad_a[i].weight
+				* weights_rad_b[j].weight * EllipsoidForm(dp, q);
+			norm += weights_rad_a[i].weight
+				* weights_rad_b[j].weight;
+		}
+	}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double EllipsoidModel :: operator()(double qx, double qy) {
+	EllipsoidParameters dp;
+	// Fill parameter array
+	dp.scale      = scale();
+	dp.radius_a   = radius_a();
+	dp.radius_b   = radius_b();
+	dp.contrast   = contrast();
+	dp.background = 0.0;
+	dp.axis_theta = axis_theta();
+	dp.axis_phi   = axis_phi();
+
+	// Get the dispersion points for the radius_a
+	vector<WeightPoint> weights_rad_a;
+	radius_a.get_weights(weights_rad_a);
+
+	// Get the dispersion points for the radius_b
+	vector<WeightPoint> weights_rad_b;
+	radius_b.get_weights(weights_rad_b);
+
+	// Get angular averaging for theta
+	vector<WeightPoint> weights_theta;
+	axis_theta.get_weights(weights_theta);
+
+	// Get angular averaging for phi
+	vector<WeightPoint> weights_phi;
+	axis_phi.get_weights(weights_phi);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad_a.size(); i++) {
+		dp.radius_a = weights_rad_a[i].value;
+
+
+		// Loop over length weight points
+		for(int j=0; j<weights_rad_b.size(); j++) {
+			dp.radius_b = weights_rad_b[j].value;
+
+			// Average over theta distribution
+			for(int k=0; k<weights_theta.size(); k++) {
+				dp.axis_theta = weights_theta[k].value;
+
+				// Average over phi distribution
+				for(int l=0; l<weights_phi.size(); l++) {
+					dp.axis_phi = weights_phi[l].value;
+
+					double _ptvalue = weights_rad_a[i].weight
+						* weights_rad_b[j].weight
+						* weights_theta[k].weight
+						* weights_phi[l].weight
+						* ellipsoid_analytical_2DXY(&dp, qx, qy);
+					if (weights_theta.size()>1) {
+						_ptvalue *= sin(weights_theta[k].value);
+					}
+					sum += _ptvalue;
+
+					norm += weights_rad_a[i].weight
+						* weights_rad_b[j].weight
+						* weights_theta[k].weight
+						* weights_phi[l].weight;
+
+				}
+			}
+		}
+	}
+	// Averaging in theta needs an extra normalization
+	// factor to account for the sin(theta) term in the
+	// integration (see documentation).
+	if (weights_theta.size()>1) norm = norm / asin(1.0);
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the cylinder
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double EllipsoidModel :: evaluate_rphi(double q, double phi) {
+	double qx = q*cos(phi);
+	double qy = q*sin(phi);
+	return (*this).operator()(qx, qy);
+}
Index: sansmodels/src/sans/models/c_models/ellipticalcylinder.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/ellipticalcylinder.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
+++ sansmodels/src/sans/models/c_models/ellipticalcylinder.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
@@ -0,0 +1,221 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ *	TODO: refactor so that we pull in the old sansmodels.c_extensions
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libCylinder.h"
+	#include "elliptical_cylinder.h"
+}
+
+EllipticalCylinderModel :: EllipticalCylinderModel() {
+	scale      = Parameter(1.0);
+	r_minor    = Parameter(20.0, true);
+	r_minor.set_min(0.0);
+	r_ratio    = Parameter(1.5, true);
+	r_ratio.set_min(0.0);
+	length     = Parameter(400.0, true);
+	length.set_min(0.0);
+	contrast   = Parameter(3.e-6);
+	background = Parameter(0.0);
+	cyl_theta  = Parameter(1.57, true);
+	cyl_phi    = Parameter(0.0, true);
+	cyl_psi    = Parameter(0.0, true);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double EllipticalCylinderModel :: operator()(double q) {
+	double dp[6];
+
+	dp[0] = scale();
+	dp[1] = r_minor();
+	dp[2] = r_ratio();
+	dp[3] = length();
+	dp[4] = contrast();
+	dp[5] = 0.0;
+
+	// Get the dispersion points for the r_minor
+	vector<WeightPoint> weights_rad;
+	r_minor.get_weights(weights_rad);
+
+	// Get the dispersion points for the r_ratio
+	vector<WeightPoint> weights_rat;
+	r_ratio.get_weights(weights_rat);
+
+	// Get the dispersion points for the length
+	vector<WeightPoint> weights_len;
+	length.get_weights(weights_len);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over r_minor weight points
+	for(int i=0; i<weights_rad.size(); i++) {
+		dp[1] = weights_rad[i].value;
+
+		// Loop over r_ratio weight points
+		for(int j=0; j<weights_rat.size(); j++) {
+			dp[2] = weights_rat[j].value;
+
+			// Loop over length weight points
+			for(int k=0; k<weights_len.size(); k++) {
+				dp[3] = weights_len[k].value;
+
+				sum += weights_rad[i].weight
+					* weights_len[k].weight
+					* weights_rat[j].weight
+					* EllipCyl20(dp, q);
+				norm += weights_rad[i].weight
+				* weights_len[k].weight
+				* weights_rat[j].weight;
+			}
+		}
+	}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double EllipticalCylinderModel :: operator()(double qx, double qy) {
+	EllipticalCylinderParameters dp;
+	// Fill parameter array
+	dp.scale      = scale();
+	dp.r_minor    = r_minor();
+	dp.r_ratio    = r_ratio();
+	dp.length     = length();
+	dp.contrast   = contrast();
+	dp.background = 0.0;
+	dp.cyl_theta  = cyl_theta();
+	dp.cyl_phi    = cyl_phi();
+	dp.cyl_psi    = cyl_psi();
+
+	// Get the dispersion points for the r_minor
+	vector<WeightPoint> weights_rad;
+	r_minor.get_weights(weights_rad);
+
+	// Get the dispersion points for the r_ratio
+	vector<WeightPoint> weights_rat;
+	r_ratio.get_weights(weights_rat);
+
+	// Get the dispersion points for the length
+	vector<WeightPoint> weights_len;
+	length.get_weights(weights_len);
+
+	// Get angular averaging for theta
+	vector<WeightPoint> weights_theta;
+	cyl_theta.get_weights(weights_theta);
+
+	// Get angular averaging for phi
+	vector<WeightPoint> weights_phi;
+	cyl_phi.get_weights(weights_phi);
+
+	// Get angular averaging for psi
+	vector<WeightPoint> weights_psi;
+	cyl_psi.get_weights(weights_psi);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over minor radius weight points
+	for(int i=0; i<weights_rad.size(); i++) {
+		dp.r_minor = weights_rad[i].value;
+
+
+		// Loop over length weight points
+		for(int j=0; j<weights_len.size(); j++) {
+			dp.length = weights_len[j].value;
+
+			// Loop over r_ration weight points
+			for(int m=0; m<weights_rat.size(); m++) {
+				dp.r_ratio = weights_rat[m].value;
+
+			// Average over theta distribution
+			for(int k=0; k<weights_theta.size(); k++) {
+				dp.cyl_theta = weights_theta[k].value;
+
+				// Average over phi distribution
+				for(int l=0; l<weights_phi.size(); l++) {
+					dp.cyl_phi = weights_phi[l].value;
+
+				// Average over phi distribution
+				for(int o=0; o<weights_psi.size(); o++) {
+					dp.cyl_psi = weights_psi[o].value;
+
+					double _ptvalue = weights_rad[i].weight
+						* weights_len[j].weight
+						* weights_rat[m].weight
+						* weights_theta[k].weight
+						* weights_phi[l].weight
+						* weights_psi[o].weight
+						* elliptical_cylinder_analytical_2DXY(&dp, qx, qy);
+					if (weights_theta.size()>1) {
+						_ptvalue *= sin(weights_theta[k].value);
+					}
+					sum += _ptvalue;
+
+					norm += weights_rad[i].weight
+						* weights_len[j].weight
+						* weights_rat[m].weight
+						* weights_theta[k].weight
+						* weights_phi[l].weight
+						* weights_psi[o].weight;
+
+				}
+				}
+			}
+			}
+		}
+	}
+	// Averaging in theta needs an extra normalization
+	// factor to account for the sin(theta) term in the
+	// integration (see documentation).
+	if (weights_theta.size()>1) norm = norm / asin(1.0);
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the cylinder
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double EllipticalCylinderModel :: evaluate_rphi(double q, double phi) {
+	double qx = q*cos(phi);
+	double qy = q*sin(phi);
+	return (*this).operator()(qx, qy);
+}
Index: sansmodels/src/sans/models/c_models/models.hh
===================================================================
--- sansmodels/src/sans/models/c_models/models.hh	(revision af03ddd0932915d6659404ab7824e4223ea2944f)
+++ sansmodels/src/sans/models/c_models/models.hh	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
@@ -24,5 +24,4 @@
 
 class CylinderModel{
-
 public:
 	// Model parameters
@@ -34,5 +33,4 @@
 	Parameter cyl_theta;
 	Parameter cyl_phi;
-	// TODO: replace this by an array of parameters
 
 	// Constructor
@@ -45,3 +43,105 @@
 };
 
+class SphereModel{
+public:
+	// Model parameters
+	Parameter radius;
+	Parameter scale;
+	Parameter contrast;
+	Parameter background;
+
+	// Constructor
+	SphereModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double evaluate_rphi(double q, double phi);
+};
+
+class CoreShellModel{
+public:
+	// Model parameters
+	Parameter radius;
+	Parameter scale;
+	Parameter thickness;
+	Parameter core_sld;
+	Parameter shell_sld;
+	Parameter solvent_sld;
+	Parameter background;
+
+	// Constructor
+	CoreShellModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double evaluate_rphi(double q, double phi);
+};
+
+class CoreShellCylinderModel{
+public:
+	// Model parameters
+	Parameter radius;
+	Parameter scale;
+	Parameter thickness;
+	Parameter length;
+	Parameter core_sld;
+	Parameter shell_sld;
+	Parameter solvent_sld;
+	Parameter background;
+	Parameter axis_theta;
+	Parameter axis_phi;
+
+	// Constructor
+	CoreShellCylinderModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double evaluate_rphi(double q, double phi);
+};
+
+class EllipsoidModel{
+public:
+	// Model parameters
+	Parameter radius_a;
+	Parameter scale;
+	Parameter radius_b;
+	Parameter contrast;
+	Parameter background;
+	Parameter axis_theta;
+	Parameter axis_phi;
+
+	// Constructor
+	EllipsoidModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double evaluate_rphi(double q, double phi);
+};
+
+class EllipticalCylinderModel{
+public:
+	// Model parameters
+	Parameter r_minor;
+	Parameter scale;
+	Parameter r_ratio;
+	Parameter length;
+	Parameter contrast;
+	Parameter background;
+	Parameter cyl_theta;
+	Parameter cyl_phi;
+	Parameter cyl_psi;
+
+	// Constructor
+	EllipticalCylinderModel();
+
+	// Operators to get I(Q)
+	double operator()(double q);
+	double operator()(double qx, double qy);
+	double evaluate_rphi(double q, double phi);
+};
+
 #endif
Index: sansmodels/src/sans/models/c_models/sphere.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/sphere.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
+++ sansmodels/src/sans/models/c_models/sphere.cpp	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
@@ -0,0 +1,95 @@
+/**
+	This software was developed by the University of Tennessee as part of the
+	Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+	project funded by the US National Science Foundation.
+
+	If you use DANSE applications to do scientific research that leads to
+	publication, we ask that you acknowledge the use of the software with the
+	following sentence:
+
+	"This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+	copyright 2008, University of Tennessee
+ */
+
+/**
+ * Scattering model classes
+ * The classes use the IGOR library found in
+ *   sansmodels/src/libigor
+ *
+ */
+
+#include <math.h>
+#include "models.hh"
+#include "parameters.hh"
+#include <stdio.h>
+using namespace std;
+
+extern "C" {
+	#include "libSphere.h"
+}
+
+SphereModel :: SphereModel() {
+	scale      = Parameter(1.0);
+	radius     = Parameter(20.0, true);
+	radius.set_min(0.0);
+	contrast   = Parameter(3.e-6);
+	background = Parameter(0.0);
+}
+
+/**
+ * Function to evaluate 1D scattering function
+ * The NIST IGOR library is used for the actual calculation.
+ * @param q: q-value
+ * @return: function value
+ */
+double SphereModel :: operator()(double q) {
+	double dp[4];
+
+	// Fill parameter array for IGOR library
+	// Add the background after averaging
+	dp[0] = scale();
+	dp[1] = radius();
+	dp[2] = contrast();
+	dp[3] = 0.0;
+
+	// Get the dispersion points for the radius
+	vector<WeightPoint> weights_rad;
+	radius.get_weights(weights_rad);
+
+	// Perform the computation, with all weight points
+	double sum = 0.0;
+	double norm = 0.0;
+
+	// Loop over radius weight points
+	for(int i=0; i<weights_rad.size(); i++) {
+		dp[1] = weights_rad[i].value;
+
+		sum += weights_rad[i].weight
+			* SphereForm(dp, q);
+		norm += weights_rad[i].weight;
+	}
+	return sum/norm + background();
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param q_x: value of Q along x
+ * @param q_y: value of Q along y
+ * @return: function value
+ */
+double SphereModel :: operator()(double qx, double qy) {
+	double q = sqrt(qx*qx + qy*qy);
+	return (*this).operator()(q);
+}
+
+/**
+ * Function to evaluate 2D scattering function
+ * @param pars: parameters of the sphere
+ * @param q: q-value
+ * @param phi: angle phi
+ * @return: function value
+ */
+double SphereModel :: evaluate_rphi(double q, double phi) {
+	return (*this).operator()(q);
+}
Index: sansmodels/src/sans/models/dispersion_models.py
===================================================================
--- sansmodels/src/sans/models/dispersion_models.py	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
+++ sansmodels/src/sans/models/dispersion_models.py	(revision 0f5bc9ff2027432913fd8d2cb067675244acdaf6)
@@ -0,0 +1,100 @@
+"""
+    This software was developed by the University of Tennessee as part of the
+    Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+    project funded by the US National Science Foundation.
+
+    If you use DANSE applications to do scientific research that leads to
+    publication, we ask that you acknowledge the use of the software with the
+    following sentence:
+
+    "This work benefited from DANSE software developed under NSF award DMR-0520547."
+
+    copyright 2008, University of Tennessee
+"""
+
+"""
+    Class definitions for python dispersion model for 
+    model parameters. These classes are bridges to the C++
+    dispersion object.
+    
+    The ArrayDispersion class takes in numpy arrays only.
+    
+    Usage:
+    These classes can be used to set the dispersion model of a SANS model
+    parameter:
+    
+        cyl = CylinderModel()
+        cyl.set_dispersion('radius', GaussianDispersion())
+    
+    
+    After the dispersion model is set, you can access it's
+    parameter through the dispersion dictionary:
+    
+        cyl.dispersion['radius']['width'] = 5.0
+    
+    TODO: For backward compatibility, the model parameters are still kept in
+    a dictionary. The next iteration of refactoring work should involve moving
+    away from value-based parameters to object-based parameter. We want to
+    store parameters as objects so that we can unify the 'params' and 'dispersion'
+    dictionaries into a single dictionary of parameter objects that hold the
+    complete information about the parameter (units, limits, dispersion model, etc...).  
+    
+    
+"""
+import sans_extension.c_models as c_models 
+
+class DispersionModel:
+    """
+        Python bridge class for a basic dispersion model 
+        class with a constant parameter value distribution
+    """
+    def __init__(self):
+        self.cdisp = c_models.new_dispersion_model()
+        
+    def set_weights(self, values, weights):
+        """
+            Set the weights of an array dispersion
+        """
+        message = "set_weights is not available for DispersionModel.\n"
+        message += "  Solution: Use an ArrayDispersion object"
+        raise "RuntimeError", message
+        
+class GaussianDispersion(DispersionModel):
+    """
+        Python bridge class for a dispersion model based 
+        on a Gaussian distribution.
+    """
+    def __init__(self):
+        self.cdisp = c_models.new_gaussian_model()
+        
+    def set_weights(self, values, weights):
+        """
+            Set the weights of an array dispersion
+        """
+        message = "set_weights is not available for GaussiantDispersion.\n"
+        message += "  Solution: Use an ArrayDispersion object"
+        raise "RuntimeError", message
+        
+class ArrayDispersion(DispersionModel):
+    """
+        Python bridge class for a dispersion model based on arrays.
+        The user has to set a weight distribution that
+        will be used in the averaging the model parameter
+        it is applied to. 
+    """
+    def __init__(self):
+        self.cdisp = c_models.new_array_model()
+        
+    def set_weights(self, values, weights):
+        """
+            Set the weights of an array dispersion
+            Only accept numpy arrays.
+            @param values: numpy array of values
+            @param weights: numpy array of weights for each value entry
+        """
+        if len(values) != len(weights):
+            raise ValueError, "ArrayDispersion.set_weights: given arrays are of different lengths"
+        
+        c_models.set_dispersion_weights(self.cdisp, values, weights)
+        
+        
